Main Page Class Hierarchy Alphabetical List Compound List File List Compound Members File Members

# TAO_ESF_Proxy_RB_Tree Class Template Reference

The Event Service Framework provides several alternatives for the underlying proxy collections. More...

`#include <ESF_Proxy_RB_Tree.h>`

Collaboration diagram for TAO_ESF_Proxy_RB_Tree:

[legend]
List of all members.

## Public Types
typedef ACE_RB_Tree< PROXY *, int, ACE_Less_Than< PROXY *>, ACE_Null_Mutex > | Implementation
| A typedef for the underlying implementaiton class. More...
typedef TAO_ESF_Proxy_RB_Tree_Iterator< PROXY > | Iterator
| A typedef for the underlying iterator. More...
## Public Methods
| TAO_ESF_Proxy_RB_Tree (void)
| Constructor. More...
TAO_ESF_Proxy_RB_Tree_Iterator< PROXY > | begin (void)
| Return the first element in the collection, or end() if there are none. More...
TAO_ESF_Proxy_RB_Tree_Iterator< PROXY > | end (void)
| Return one past the last element in the collection. More...
size_t | size (void) const
| Return the number of elements in the collection. More...
void | connected (PROXY *ACE_ENV_ARG_DECL_NOT_USED)
| Insert a new element to the collection. More...
void | reconnected (PROXY *ACE_ENV_ARG_DECL_NOT_USED)
| Insert a new element that could be there already. More...
void | disconnected (PROXY *ACE_ENV_ARG_DECL_NOT_USED)
| Remove an element from the collection. More...
void | shutdown (ACE_ENV_SINGLE_ARG_DECL_NOT_USED)
| Shutdown the collection, i.e. remove all elements and release resources. More...
## Private Attributes
Implementation | impl_
| The underlying implementation object. More...

## Detailed Description

### template<class PROXY>
class TAO_ESF_Proxy_RB_Tree< PROXY >

The Event Service Framework provides several alternatives for the underlying proxy collections.

This version is based on Red-Black trees that offer good insertion, removal and lookup performance, but the iteration is slightly degraded.

## Member Typedef Documentation

template<class PROXY>
typedef ACE_RB_Tree<PROXY*,int,ACE_Less_Than<PROXY*>,ACE_Null_Mutex> TAO_ESF_Proxy_RB_Tree::Implementation

| A typedef for the underlying implementaiton class.

template<class PROXY>
typedef TAO_ESF_Proxy_RB_Tree_Iterator<PROXY> TAO_ESF_Proxy_RB_Tree::Iterator

| A typedef for the underlying iterator.

## Constructor & Destructor Documentation

template<class PROXY>
TAO_ESF_Proxy_RB_Tree< PROXY >::TAO_ESF_Proxy_RB_Tree | ( | void |  | ) |

| Constructor.

## Member Function Documentation

template<class PROXY>
ACE_INLINE TAO_ESF_Proxy_RB_Tree_Iterator< PROXY > TAO_ESF_Proxy_RB_Tree< PROXY >::begin | ( | void |  | ) |

| Return the first element in the collection, or end() if there are none.

template<class PROXY>
void TAO_ESF_Proxy_RB_Tree< PROXY >::connected | ( | PROXY * | ACE_ENV_ARG_DECL_NOT_USED | ) |

| Insert a new element to the collection.

template<class PROXY>
void TAO_ESF_Proxy_RB_Tree< PROXY >::disconnected | ( | PROXY * | ACE_ENV_ARG_DECL_NOT_USED | ) |

| Remove an element from the collection.

template<class PROXY>
ACE_INLINE TAO_ESF_Proxy_RB_Tree_Iterator< PROXY > TAO_ESF_Proxy_RB_Tree< PROXY >::end | ( | void |  | ) |

| Return one past the last element in the collection.

template<class PROXY>
void TAO_ESF_Proxy_RB_Tree< PROXY >::reconnected | ( | PROXY * | ACE_ENV_ARG_DECL_NOT_USED | ) |

| Insert a new element that could be there already.

template<class PROXY>
void TAO_ESF_Proxy_RB_Tree< PROXY >::shutdown | ( | ACE_ENV_SINGLE_ARG_DECL_NOT_USED |  | ) |

| Shutdown the collection, i.e. remove all elements and release resources.

template<class PROXY>
ACE_INLINE size_t TAO_ESF_Proxy_RB_Tree< PROXY >::size | ( | void |  | ) | const

| Return the number of elements in the collection.

## Member Data Documentation

template<class PROXY>
Implementation TAO_ESF_Proxy_RB_Tree::impl_`[private]`

| The underlying implementation object.

The documentation for this class was generated from the following files:

- ESF_Proxy_RB_Tree.h
- ESF_Proxy_RB_Tree.cpp
- ESF_Proxy_RB_Tree.i